#!/bin/sh

function displayscores {

clear

echo "##########################"
echo "Top scores:"
cat highscores.txt
echo "##########################"
echo "Current final score:"
cat difficulty.txt
echo "##########################"

}

function testquit {

 if [ "x$input" == "xquit" ]
  then 
  displayscores
  exit 0
 fi

 if [ "x$input" == "xexit" ]
  then 
  displayscores
  exit 0
 fi

 if [ "x$input" == "xbye" ]
  then 
  displayscores
  exit 0
 fi

}

function scoring {

 if (($MIXED == 0))
 then

  if [ "$input" = "$result" ]
  then
   difficulty=$(($difficulty + 1))
   sed -i -e "s/$compute=.*/$compute=$difficulty/g" difficulty.txt
   echo Good !
  fi

  if [ "$input" != "$result" ]&& (( $difficulty <= 1 ))
  then
   echo Ahem !
   echo "The good result is $result !"
  fi

  if [ "$input" != "$result" ]&& (( $difficulty > 1 ))
  then
   difficulty=$(($difficulty - 1))
   sed -i -e "s/$compute=.*/$compute=$difficulty/g" difficulty.txt
   echo Boohoohoo !
   echo "The good result is $result !"
  fi

 fi

 if (($MIXED == 1))
 then

  if [ "$input" = "$result" ]
  then
   difficulty=$(($difficulty + 1))
   sed -i -e "s/mixed=.*/mixed=$difficulty/g" difficulty.txt
   echo Good !
  fi

  if [ "$input" != "$result" ]&& (( $difficulty <= 1 ))
  then
   echo Ahem !
   echo "The good result is $result !"
  fi

  if [ "$input" != "$result" ]&& (( $difficulty > 1 ))
  then
   difficulty=$(($difficulty - 1))
   sed -i -e "s/mixed=.*/mixed=$difficulty/g" difficulty.txt
   echo Boohoohoo !
   echo "The good result is $result !"
  fi

 fi

}

function highscoring {

 difficulty="cat difficulty.txt | grep $compute | grep -o -E '[[:digit:]]+'"
 difficulty=$(eval $difficulty)

 highdifficulty="cat highscores.txt | grep $compute | grep -o -E '[[:digit:]]+'"
 highdifficulty=$(eval $highdifficulty)

 if (( "$difficulty" > "$highdifficulty" ))
 then
  sed -i -e "s/$compute=.*/$compute=$difficulty/g" highscores.txt
 fi

}

function addition {

 difficulty="cat difficulty.txt | grep $compute | grep -o -E '[[:digit:]]+'"
 difficulty=$(eval $difficulty)

 nb1=$RANDOM
 let "nb1 %= $difficulty"
 nb1=$(($nb1 + 1))

 nb2=$RANDOM
 let "nb2 %= $difficulty"
 nb2=$(($nb2 + 1))

 result=$(($nb1 + $nb2))

 echo "$nb1 + $nb2 = ?"

 read input

 testquit

 scoring

 highscoring

 echo

}

function substraction {

 difficulty="cat difficulty.txt | grep $compute | grep -o -E '[[:digit:]]+'"
 difficulty=$(eval $difficulty)

 nb1=$RANDOM
 let "nb1 %= $difficulty"
 nb1=$(($nb1 + 1))

 nb2=$RANDOM
 let "nb2 %= $difficulty"
 nb2=$(($nb2 + 1))

 result=$(($nb1 - $nb2))

 echo "$nb1 - $nb2 = ?"

 read input

 testquit

 scoring

 highscoring

 echo

}

function multiplication {

 difficulty="cat difficulty.txt | grep $compute | grep -o -E '[[:digit:]]+'"
 difficulty=$(eval $difficulty)

 nb1=$RANDOM
 let "nb1 %= $difficulty"
 nb1=$(($nb1 + 1))

 nb2=$RANDOM
 let "nb2 %= $difficulty"
 nb2=$(($nb2 + 1))

 result=$(($nb1 * $nb2))

 echo "$nb1 X $nb2 = ?"

 read input

 testquit

 scoring

 highscoring

 echo

}

function division {

 difficulty="cat difficulty.txt | grep $compute | grep -o -E '[[:digit:]]+'"
 difficulty=$(eval $difficulty)

 nb1=$RANDOM
 let "nb1 %= $difficulty"
 nb1=$(($nb1 + 1))

 nb2=$RANDOM
 let "nb2 %= $difficulty"
 nb2=$(($nb2 + 1))

 resultpart1=$(echo "$nb1 / $nb2" | bc -l | cut -d . -f1)

 resultpart2=$(echo "$nb1 / $nb2" | bc -l | cut -d . -f2 | cut -c 1)

 resultpart3=$(echo "$nb1 / $nb2" | bc -l | cut -d . -f2 | cut -c 2)

 if (($resultpart3 > 5))
 then
  resultpart2=$(($resultpart2 + 1))
 fi

 if (($resultpart2 != 0))
 then
  result=$resultpart1.$resultpart2
 else
  result=$resultpart1
 fi

 echo "$nb1 / $nb2 = ?"

 read input

 testquit

 scoring

 highscoring

 echo

}

function mixed {

 difficulty="cat difficulty.txt | grep $compute | grep -o -E '[[:digit:]]+'"
 difficulty=$(eval $difficulty)

 RANGE=4
 rndchoice=$RANDOM
 let "rndchoice %= $RANGE"

 case $rndchoice in
  0 )
   echo addition > compute; addition ;;
  1 )
   substraction ;;
  2 )
   multiplication ;;
  3 )
   division ;;
 esac

}

clear

#Splash Screen
echo "Welcome to EvalMaster 1.0 !"
echo "A GPLV3 bash program by Linux-SWAT !"
echo ""
echo "Story:"
echo "Your computer has a failure !!!"
echo "Now it's HIM who asks YOU to compute !!!"
echo ""
echo "----------------------------------------------"
echo "Type exit, quit or bye to stop this program."
echo "----------------------------------------------"
echo ""
echo "----------------------------------------------"
echo "Please push [ENTER] to help your confused CPU."
echo "Gg, hf gl !!!"
echo "----------------------------------------------"

read input

if [ "x$input" == "xquit" ]
 then 
 exit 0
fi

if [ "x$input" == "xexit" ]
 then 
 exit 0
fi

if [ "x$input" == "xbye" ]
 then 
 exit 0
fi

clear

#Choose the game mode
echo "----------------------------------------------"
echo "Current difficulty level:"
echo "----------------------------------------------"
cat difficulty.txt
echo ""
echo "----------------------------------------------"
echo "Choose your computation:"
echo "1 addition"
echo "2 substraction"
echo "3 multiplication"
echo "4 division (results are rounded, e.g. 2/3 = .7)"
echo "5 mixed"
echo "----------------------------------------------"

while read input; do

 testquit

 if [ "x$input" == "x1" ]
 then
  operation=add
  break
 fi

 if [ "x$input" == "x2" ]
 then
  operation=sub
  break
 fi

 if [ "x$input" == "x3" ]
 then
  operation=mul
  break
 fi

 if [ "x$input" == "x4" ]
 then
  operation=div
  break
 fi

 if [ "x$input" == "x5" ]
 then
  operation=mix
  break
 fi

done

case $operation in
 add )
  MIXED=0
  compute=addition
  while true; do addition; done ;;
 sub )
  MIXED=0
  compute=substraction
  while true; do substraction; done ;;
 mul )
  MIXED=0
  compute=multiplication
  while true; do multiplication; done ;;
 div )
  MIXED=0
  compute=division
  while true; do division; done ;;
 mix )
  MIXED=1
  compute=mixed
  while true; do mixed; done ;;
esac


